#!/usr/bin/env batchflow
<?xml version="1.0"?>
<Document>
  <Network type="subnet" name="MAIN">
    <Node name="node_Constant_1" type="Constant" x="60" y="70">
      <Parameter name="VALUE" type="subnet_param" value="ARG1" description="The value"/>
    </Node>
    <Node name="node_InputStream_1" type="InputStream" x="260" y="70">
      <Parameter name="TYPE" type="String" value="" description="Type of stream: stream, fd, or FILE (default stream)"/>
      <Parameter name="RETRY" type="int" value="" description="If set to N, InputStream will retry N times on open fail"/>
    </Node>
    <Node name="node_MAIN_LOOP_1" type="MAIN_LOOP" x="480" y="70">
      <Parameter name="LENGTH" type="int" value="512" description="The frame length of each channel (in samples) [default: 512]."/>
      <Parameter name="ADVANCE" type="int" value="160" description="The shift length beween adjacent frames (in samples)[default: 160]."/>
    </Node>
    <Link from="node_Constant_1" output="VALUE" to="node_InputStream_1" input="INPUT"/>
    <Link from="node_InputStream_1" output="OUTPUT" to="node_MAIN_LOOP_1" input="INPUT"/>
    <NetOutput name="OUTPUT_AUDIO_SIGNAL" node="node_MAIN_LOOP_1" terminal="OUTPUT_AUDIO_SIGNAL" object_type="any" description="Dynamic"/>
    <NetOutput name="OUTPUT_TRACKED_DOA" node="node_MAIN_LOOP_1" terminal="OUTPUT_TRACKED_DOA" object_type="any" description="Dynamic"/>
  </Network>
  <Network type="iterator" name="MAIN_LOOP">
    <Node name="node_MultiFFT_1" type="MultiFFT" x="840" y="100">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="FFT length in sample. [default: 512]"/>
      <Parameter name="WINDOW" type="string" value="CONJ" description="A window function for FFT. WINDOW should be CONJ, HAMMING, RECTANGLE, or HANNING. [default: CONJ]"/>
      <Parameter name="WINDOW_LENGTH" type="subnet_param" value="LENGTH" description="Window length of the window function. [default: 512]"/>
    </Node>
    <Node name="node_AudioStreamFromWave_1" type="AudioStreamFromWave" x="100" y="100">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="The frame length of each channel (in samples) [default: 512]."/>
      <Parameter name="ADVANCE" type="subnet_param" value="ADVANCE" description="The shift length beween adjacent frames (in samples)[default: 160]."/>
      <Parameter name="USE_WAIT" type="bool" value="true" description="If true, real recording is simulated [default: false]."/>
    </Node>
    <Node name="node_MultiGain_1" type="MultiGain" x="650" y="100">
      <Parameter name="GAIN" type="float" value="0.0009765625" description="Gain factor."/>
    </Node>
    <Node name="node_ChannelSelector_1" type="ChannelSelector" x="400" y="100">
      <Parameter name="SELECTOR" type="object" value="&lt;Vector&lt;int&gt; 2 6&gt;" description="Channel selection setting which is a vector consisting of channel IDs (ID starts with 0). When the first three channels are selected from four channels, this should be set to &amp;lt;Vector&amp;lt;int&amp;gt; 0 1 2&amp;gt;."/>
    </Node>
    <Node name="node_BinauralMultisourceLocalization_1" type="BinauralMultisourceLocalization" x="100" y="240">
      <Parameter name="SOUND_DIFFRACTION_COMPENSATION" type="string" value="FREE_SPACE" description="Compensation for the diffraction of sound waves with multi-path interference caused by contours of a spherical robot head [default: FREE_SPACE]."/>
      <Parameter name="GCCPHAT_THRESHOLD" type="float" value="0.25" description="Threshold to avoid estimating DOAs of noise and reverberated sources [default: 0.25 (0.0 - 1.0)]."/>
      <Parameter name="MICS_DISTANCE" type="float" value="7.3" description="Distance between two microphones (cm) [default: 17.4]."/>
      <Parameter name="NOISE_DURATION" type="float" value="1" description="Time duration to be regarded as &quot;noise&quot; from the first frame [default: 1.0 seconds]."/>
      <Parameter name="FREQUENCY_HIGH" type="float" value="7000" description="Upper bound of frequency range where GCC-PHAT is calculated [default: 7000.0 Hz]"/>
      <Parameter name="FREQUENCY_LOW" type="float" value="60" description="Lower bound of frequency range where GCC-PHAT is calculated [default: 60.0 Hz]"/>
      <Parameter name="ADVANCE" type="int" value="160" description="The length in sample between a frame and a previous frame [default: 160]."/>
      <Parameter name="SAMPLING_RATE" type="int" value="16000" description="Sampling rate (Hz) [default: 16000]."/>
    </Node>
    <Node name="node_BinauralMultisourceTracker_1" type="BinauralMultisourceTracker" x="490" y="240">
      <Parameter name="CLUSTERING_DURATION" type="float" value="0.25" description="Time duration to cluster direction estimations [default: 0.25 seconds]."/>
      <Parameter name="ADVANCE" type="int" value="160" description="The length in sample between a frame and a previous frame [default: 160]."/>
      <Parameter name="SAMPLING_RATE" type="int" value="16000" description="Sampling rate (Hz) [default: 16000]."/>
    </Node>
    <Node name="node_SSLvisualization_1" type="SSLvisualization" x="830" y="220">
      <Parameter name="WINDOW_NAME" type="string" value="Visualization of multisource directions" description="Window name of the time-azimuth map [default: Visualization of multisource directions]."/>
      <Parameter name="VISUALIZATION_TIME_LENGTH" type="float" value="10" description="Visualization window length to show at the same time [default: 10.0 seconds]."/>
      <Parameter name="ADVANCE" type="int" value="160" description="The length in sample between a frame and a previous frame [default: 160]."/>
      <Parameter name="SAMPLING_RATE" type="int" value="16000" description="Sampling rate (Hz) [default: 16000]."/>
    </Node>
    <Link from="node_MultiGain_1" output="OUTPUT" to="node_MultiFFT_1" input="INPUT"/>
    <Link from="node_AudioStreamFromWave_1" output="AUDIO" to="node_ChannelSelector_1" input="INPUT"/>
    <Link from="node_ChannelSelector_1" output="OUTPUT" to="node_MultiGain_1" input="INPUT"/>
    <Link from="node_BinauralMultisourceLocalization_1" output="ESTIMATED_DOA" to="node_BinauralMultisourceTracker_1" input="ESTIMATED_DOA"/>
    <Link from="node_MultiFFT_1" output="OUTPUT" to="node_BinauralMultisourceLocalization_1" input="AUDIO_SPECTRUM"/>
    <Link from="node_MultiGain_1" output="OUTPUT" to="node_SSLvisualization_1" input="INPUT_AUDIO_SIGNAL"/>
    <Link from="node_BinauralMultisourceTracker_1" output="TRACKED_DOA" to="node_SSLvisualization_1" input="INPUT_TRACKED_DOA"/>
    <NetInput name="INPUT" node="node_AudioStreamFromWave_1" terminal="INPUT" object_type="Stream" description="An audio input stream (IStream)."/>
    <NetCondition name="CONDITION" node="node_AudioStreamFromWave_1" terminal="NOT_EOF"/>
    <NetOutput name="OUTPUT_AUDIO_SIGNAL" node="node_SSLvisualization_1" terminal="OUTPUT_AUDIO_SIGNAL" object_type="any" description="Same as input"/>
    <NetOutput name="OUTPUT_TRACKED_DOA" node="node_SSLvisualization_1" terminal="OUTPUT_TRACKED_DOA" object_type="Vector&amp;lt;ObjectRef&amp;gt;" description="Same as input"/>
  </Network>
</Document>
