#!/usr/bin/env batchflow
<?xml version="1.0"?>
<Document>
  <Network type="subnet" name="MAIN">
    <Node name="node_Constant_1" type="Constant" x="60" y="70">
      <Parameter name="VALUE" type="subnet_param" value="ARG1" description="The value"/>
    </Node>
    <Node name="node_InputStream_1" type="InputStream" x="260" y="70">
      <Parameter name="TYPE" type="String" value="" description="Type of stream: stream, fd, or FILE (default stream)"/>
      <Parameter name="RETRY" type="int" value="" description="If set to N, InputStream will retry N times on open fail"/>
    </Node>
    <Node name="node_MAIN_LOOP_1" type="MAIN_LOOP" x="480" y="70">
      <Parameter name="LENGTH" type="int" value="512" description="The frame length of each channel (in samples) [default: 512]."/>
      <Parameter name="ADVANCE" type="int" value="160" description="The shift length beween adjacent frames (in samples)[default: 160]."/>
    </Node>
    <Link from="node_Constant_1" output="VALUE" to="node_InputStream_1" input="INPUT"/>
    <Link from="node_InputStream_1" output="OUTPUT" to="node_MAIN_LOOP_1" input="INPUT"/>
    <NetOutput name="OUTPUT" node="node_MAIN_LOOP_1" terminal="OUTPUT" object_type="any" description="Dynamic"/>
  </Network>
  <Network type="iterator" name="MAIN_LOOP">
    <Node name="node_MultiFFT_1" type="MultiFFT" x="840" y="100">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="FFT length in sample. [default: 512]"/>
      <Parameter name="WINDOW" type="string" value="CONJ" description="A window function for FFT. WINDOW should be CONJ, HAMMING, RECTANGLE, or HANNING. [default: CONJ]"/>
      <Parameter name="WINDOW_LENGTH" type="subnet_param" value="LENGTH" description="Window length of the window function. [default: 512]"/>
    </Node>
    <Node name="node_AudioStreamFromWave_1" type="AudioStreamFromWave" x="100" y="100">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="The frame length of each channel (in samples) [default: 512]."/>
      <Parameter name="ADVANCE" type="subnet_param" value="ADVANCE" description="The shift length beween adjacent frames (in samples)[default: 160]."/>
      <Parameter name="USE_WAIT" type="bool" value="true" description="If true, real recording is simulated [default: false]."/>
    </Node>
    <Node name="node_MultiGain_1" type="MultiGain" x="650" y="100">
      <Parameter name="GAIN" type="float" value="0.0009765625" description="Gain factor."/>
    </Node>
    <Node name="node_ChannelSelector_1" type="ChannelSelector" x="400" y="100">
      <Parameter name="SELECTOR" type="object" value="&lt;Vector&lt;int&gt; 2 6&gt;" description="Channel selection setting which is a vector consisting of channel IDs (ID starts with 0). When the first three channels are selected from four channels, this should be set to &amp;lt;Vector&amp;lt;int&amp;gt; 0 1 2&amp;gt;."/>
    </Node>
    <Node name="node_SpectrumVisualization_1" type="SpectrumVisualization" x="100" y="210">
      <Parameter name="WINDOW_NAME" type="string" value="Visualization of audio spectrum" description="Window name of the time-azimuth map [default: Visualization of audio spectrum]."/>
      <Parameter name="VISUALIZATION_TIME_LENGTH" type="float" value="10" description="Visualization window length to show at the same time [default: 10.0 seconds]."/>
      <Parameter name="ADVANCE" type="int" value="160" description="The length in sample between a frame and a previous frame [default: 160]."/>
      <Parameter name="SAMPLING_RATE" type="int" value="16000" description="Sampling rate (Hz) [default: 16000]."/>
    </Node>
    <Node name="node_SpectrumVisualization_2" type="SpectrumVisualization" x="100" y="320">
      <Parameter name="WINDOW_NAME" type="string" value="Visualization of audio spectrum" description="Window name of the time-azimuth map [default: Visualization of audio spectrum]."/>
      <Parameter name="VISUALIZATION_TIME_LENGTH" type="float" value="10" description="Visualization window length to show at the same time [default: 10.0 seconds]."/>
      <Parameter name="ADVANCE" type="int" value="160" description="The length in sample between a frame and a previous frame [default: 160]."/>
      <Parameter name="SAMPLING_RATE" type="int" value="16000" description="Sampling rate (Hz) [default: 16000]."/>
    </Node>
    <Node name="node_SourceSeparation_1" type="SourceSeparation" x="540" y="210">
      <Parameter name="ITERATION_METHOD" type="string" value="[FastIVA]NEWTON_METHOD_WITH_FIXED_POINT_ITERATION" description="iteration method [default: [FastIVA]NEWTON_METHOD_WITH_FIXED_POINT_ITERATION]."/>
      <Parameter name="MAX_ITERATION" type="int" value="700" description="Processing limitation: maximum number of iterations [default: 700]."/>
      <Parameter name="NUMBER_OF_SOURCES_TO_BE_SEPARATED" type="int" value="2" description="Number Of sound sources to be separated [default: 2]."/>
      <Parameter name="SEPARATION_TIME_LENGTH" type="float" value="5" description="Separation window length (s) [default: 5.0 seconds]."/>
      <Parameter name="ADVANCE" type="int" value="160" description="The length in sample between a frame and a previous frame [default: 160]."/>
      <Parameter name="SAMPLING_RATE" type="int" value="16000" description="Sampling rate (Hz) [default: 16000]."/>
    </Node>
    <Node name="node_MatrixToMap_1" type="MatrixToMap" x="530" y="320">
      <Parameter name="OUTPUT_TYPE" type="string" value="map_of_row_vectors" description="Type of the output. If map_of_matrix is selected, the key is zero and the value is the input Matrix. If map_of_row_vectors is selected, the keys are the row indices and the values are Vectors extracted the row components. If map_of_column_vectors is selected, the keys are the column indices and the values are Vectors ectracted the column components. [default: map_of_row_vectors]"/>
      <Parameter name="DEBUG" type="bool" value="false" description="Show debug points. [default: false]"/>
    </Node>
    <Node name="node_Synthesize_1" type="Synthesize" x="730" y="320">
      <Parameter name="LENGTH" type="int" value="512" description="Size of window length in sample. [default: 512]"/>
      <Parameter name="ADVANCE" type="int" value="160" description="The length in sample between a frame and a previous frame. [default: 160]"/>
      <Parameter name="SAMPLING_RATE" type="int" value="16000" description="Sampling rate (Hz) [default: 16000]."/>
      <Parameter name="MIN_FREQUENCY" type="int" value="125" description="Minimum frequency (Hz) [default: 125]"/>
      <Parameter name="MAX_FREQUENCY" type="int" value="7900" description="Maximum frequency (Hz) [default: 7900]"/>
      <Parameter name="WINDOW" type="string" value="HAMMING" description="A window function for overlap-add. WINDOW should be CONJ, HAMMING, RECTANGLE, or HANNING. [default: HAMMING]"/>
      <Parameter name="OUTPUT_GAIN" type="float" value="1" description="Output gain factor. [default: 1.0]"/>
    </Node>
    <Node name="node_SaveWavePCM_1" type="SaveWavePCM" x="920" y="320">
      <Parameter name="BASENAME" type="string" value="sep_" description="Basename of files. [default: sep_]"/>
      <Parameter name="ADVANCE" type="int" value="160" description="The shift length beween adjacent frames (in samples)[default: 160]."/>
      <Parameter name="SAMPLING_RATE" type="int" value="16000" description="Sampling rate (in samples)[default: 16000]."/>
      <Parameter name="BITS" type="string" value="int16" description="Bit format of samples. int16 and int24  bits are supported."/>
      <Parameter name="INPUT_BITS" type="string" value="as_BITS" description="Bit format of input wav file."/>
    </Node>
    <Link from="node_MultiGain_1" output="OUTPUT" to="node_MultiFFT_1" input="INPUT"/>
    <Link from="node_AudioStreamFromWave_1" output="AUDIO" to="node_ChannelSelector_1" input="INPUT"/>
    <Link from="node_ChannelSelector_1" output="OUTPUT" to="node_MultiGain_1" input="INPUT"/>
    <Link from="node_SpectrumVisualization_1" output="OUTPUT_AUDIO_SPECTRUM" to="node_SourceSeparation_1" input="INPUT_AUDIO_SPECTRUM"/>
    <Link from="node_MultiFFT_1" output="OUTPUT" to="node_SpectrumVisualization_1" input="INPUT_AUDIO_SPECTRUM"/>
    <Link from="node_SourceSeparation_1" output="OUTPUT_AUDIO_SPECTRUM" to="node_SpectrumVisualization_2" input="INPUT_AUDIO_SPECTRUM"/>
    <Link from="node_SpectrumVisualization_2" output="OUTPUT_AUDIO_SPECTRUM" to="node_MatrixToMap_1" input="INPUT"/>
    <Link from="node_MatrixToMap_1" output="OUTPUT" to="node_Synthesize_1" input="INPUT"/>
    <Link from="node_Synthesize_1" output="OUTPUT" to="node_SaveWavePCM_1" input="INPUT"/>
    <NetInput name="INPUT" node="node_AudioStreamFromWave_1" terminal="INPUT" object_type="Stream" description="An audio input stream (IStream)."/>
    <NetCondition name="CONDITION" node="node_AudioStreamFromWave_1" terminal="NOT_EOF"/>
    <NetOutput name="OUTPUT" node="node_SaveWavePCM_1" terminal="OUTPUT" object_type="Map&amp;lt;int,ObjectRef&amp;gt;" description="The same as input."/>
  </Network>
</Document>
